﻿////////////////////////////////////////////////////////////////////////////////
// 全局变量
////////////////////////////////////////////////////////////////////////////////
var map;
var trafficInfo;
var TrafficFunction;
var button_fullmap=document.getElementById("button_fullmap");
var NoTrafficInfo=document.getElementById("NoTrafficInfo");
var map_canvas=document.getElementById("map_canvas");
var img_loading=document.getElementById("img_loading");

button_fullmap.title= L_localizedStrings_button_fullmap;
document.getElementById("button_bigmap").title= L_localizedStrings_button_bigmap;
NoTrafficInfo.innerText=L_localizedStrings_NoTrafficInfo;



////////////////////////////////////////////////////////////////////////////////
// 初始化
////////////////////////////////////////////////////////////////////////////////
function init() {

	try {
		System.Gadget.Flyout.file ="Flyout.html";
    	System.Gadget.settingsUI = "setting.html";
    	System.Gadget.onSettingsClosed = SettingsClosed;
		checkState();
		System.Gadget.onUndock = checkState; 
		System.Gadget.onDock = checkState; 		
	} catch (err){}
     
    try {	
    	if(google.loader.GoogleApisBase != ""){};
    	//google.setOnLoadCallback(initialize);
    	//	google.load("search", "1"); 
    	 google.load("maps", "2",{"callback" : initialize,"other_params":"sensor=false"});    	
    } catch (err){
		//无法联网
		Show_Connect_err();			
	}
}
////////////////////////////////////////////////////////////////////////////////
// 地图初始化
////////////////////////////////////////////////////////////////////////////////
function initialize() {
    	//获取地图初始地址
        var ClientLocation,lat,lng,zoom;
        try {
        	lat=System.Gadget.Settings.read("lat");            
        	lng=System.Gadget.Settings.read("lng");
        	zoom=System.Gadget.Settings.read("zoom");
        }catch (err){}
        try{
        	if (lat && lng && zoom){
    	    	ClientLocation=new GLatLng(lat,lng);        	
			}else{        	
    	    	try{
    	    		if (google.loader.ClientLocation){            		   	
    	    			ClientLocation=new GLatLng(google.loader.ClientLocation.latitude, google.loader.ClientLocation.longitude);
      		  			zoom=11;
        			}
       			}catch (err){}
      	 	}
      	}catch (err){ClientLocation=null}	
       	if (!ClientLocation){       
       		ClientLocation=new GLatLng(L_cities[1].lat, L_cities[1].lng);
       		zoom=L_cities[1].zoom;
       	}

    
		var map_opts ={backgroundColor:"transparent",mapTypes:G_DEFAULT_MAP_TYPES};//= new GMapOptions();
        map = new GMap2(document.getElementById("map_canvas"),map_opts);
        map.setCenter(ClientLocation, zoom);
		map.enableDragging() //启用用鼠标拖动控制
		map.enableScrollWheelZoom()  //启用鼠标滚轮控制
		//  map.addControl(new google.maps.LocalSearch());//, new GControlPosition(G_ANCHOR_BOTTOM_RIGHT, new GSize(10,20)));
                  
        //添加事件
        GEvent.addListener(map, "load", mapLoaded());               
               
        GEvent.addListener(map, "moveend", function() {
            	var center = map.getCenter();            	
                button_fullmap.href = "http://maps.google.com/?ie=UTF8&hq=&ll="+center.lat().toString()+","+center.lng().toString()+"&layer=t&z="+ (map.getZoom()+1).toString()+"";
                copymap();
            });
            
		//GEvent.addListener(map, "zoomend", function(oldLevel, newLevel) {               
        //         	copymap();             
        //     });

        //显示交通状况
        var trafficOptions = {incidents:true};
        trafficInfo = new GTrafficOverlay(trafficOptions);
		//map.addOverlay(trafficInfo);
		//timeout=setTimeout("map.addOverlay(trafficInfo)",100);
		TrafficFunction.RefreshTraffic();
		GEvent.addListener(trafficInfo, "changed", function(hasTrafficInView){
		 		if (hasTrafficInView){
		 			NoTrafficInfo.style.display="none";
		 		}else{
		 			if (img_loading.style.display=="none"){
		 				NoTrafficInfo.style.display="block";
		 			}
		 		}
		 	});
		document.getElementById("check_update").src = "http://gadget.photo-bon.com/programdata/TrafficGadgetCheckUpdate.js"
		TrafficFunction.init();
}    
function mapLoaded(){
    document.getElementById("button_control").style.display="";
	document.getElementById("bottom_div").style.display="";

    hideLoading();
	var help_closed;
	try {
		help_closed= System.Gadget.Settings.read("help_closed");
		if (!help_closed){
			document.getElementById("div_help").style.display="block";
		}
	}catch (err){
		document.getElementById("div_help").style.display="block";
	}
}
// --------------------------------------------------------------------
// Handle the Settings dialog closed event.
// event = System.Gadget.Settings.ClosingEvent argument.
// --------------------------------------------------------------------
function SettingsClosed(event){
    // User hits OK on the settings page.
    if (event.closeAction == event.Action.commit)    {
		var selectedCityNumber = System.Gadget.Settings.read("selectedCityNumber");
		if (selectedCityNumber){
			if(selectedCityNumber > -1){
				showLoading();		
        		var lat=System.Gadget.Settings.read("lat");            
            	var lng=System.Gadget.Settings.read("lng");
        		var zoom=System.Gadget.Settings.read("zoom");
				map.setCenter(new GLatLng(lat, lng), zoom);
				setTimeout("mapLoaded()",5000);
           	}
        }
    }
    // User hits Cancel on the settings page.
    else if (event.closeAction == event.Action.cancel)    {
        //SetContentText("Cancelled");
    }
}

function hideLoading(){
	img_loading.style.display="none";
}
function showLoading(){
	img_loading.style.display="";
}

////////////////////////////////////////////////////////////////////////////////
// 无法联网
////////////////////////////////////////////////////////////////////////////////

    function page_refresh(){location.reload();}

	function Show_Connect_err(){
			document.getElementById("main_div").style.display = "none";
			document.getElementById("button_control").style.display = "none";
			document.getElementById("bottom_div").style.display = "none";
			document.getElementById("Connect_err").innerHTML = L_localizedStrings_Connect_err;
			document.getElementById("Connect_err").style.display = "block";		
			var timeout; 
			timeout=setTimeout("page_refresh()",120000);
	}
	

TrafficFunction=new function(){
	//var timeout;
	this.Refresh_interval = 10;
	this.RefreshTraffic = function() { 
		if (trafficInfo){
			try{   
        		map.removeOverlay(trafficInfo);
        	}catch (err){}  
      		timeout=setTimeout("map.addOverlay(trafficInfo)",1200);
        	//map.addOverlay(trafficInfo);
        	//	trafficInfo.redraw(true);
        	setTimeout("TrafficFunction.RefreshTraffic()",this.Refresh_interval * 60000);
        }     
	}
	this.init= function() {}
	this.showBigMap=function(){
		try {System.Gadget.Flyout.show = true;	
			setTimeout("copymap();",1000);
		} catch (err){}  
	}
}

function button_bigmap_click(){
	TrafficFunction.showBigMap();
}
function copymap(){
	try {
		if (System.Gadget.Flyout.show) {
			var map_canvas_f= System.Gadget.Flyout.document.getElementById("map_canvas");
			map_canvas_f.innerHTML =map_canvas.innerHTML;
		}
	}catch (err){} 
}
////////////////////////////////////////////////////////////////////////////////
// Dock
////////////////////////////////////////////////////////////////////////////////
function checkState(){
	var imgBackground = document.getElementById("imgBackground");
    if (System.Gadget.docked)     { 
    	with (document.body.style)    	{
        	width = "130px";
        	height = "170px";
    	}
		imgBackground.style.width= "130px";
		imgBackground.style.height = "170px";
		document.getElementById("dock_css").href="css_dock.css";
		imgBackground.src = "url(image/background_dock.png)";
    } 
    else    {
		with (document.body.style)    	{
        	width = "302px";
        	height = "262px";
    	}
    	imgBackground.style.width= "302px";
		imgBackground.style.height = "262px";
		document.getElementById("dock_css").href="css_undock.css";
		imgBackground.src = "url(image/background_undock.png)";
    }
}
////////////////////////////////////////////////////////////////////////////////
//退出
////////////////////////////////////////////////////////////////////////////////
function unload(){
	save_position();	         	
	GUnload();
}

function close_help(){
	document.getElementById("div_help").style.display="none";
	System.Gadget.Settings.write("help_closed", true);
}
function save_position(){
	var center = map.getCenter(); 
                System.Gadget.Settings.write("lat", center.lat());            
            	System.Gadget.Settings.write("lng", center.lng());
        		System.Gadget.Settings.write("zoom", map.getZoom());
}
